;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.0.3 #11834 (MINGW64)
;--------------------------------------------------------
	.module main
	.optsdcc -mstm8
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _main
	.globl _TM1637_send
	.globl _TM1637_init
	.globl _TM1637_writeByte
	.globl _TM1637_stop
	.globl _TM1637_start
	.globl _command3
	.globl _symbol_4
	.globl _symbol_3
	.globl _symbol_2
	.globl _symbol_1
	.globl _command2
	.globl _command1
	.globl _pack
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area DATA
_pack::
	.ds 2
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area INITIALIZED
_command1::
	.ds 1
_command2::
	.ds 1
_symbol_1::
	.ds 1
_symbol_2::
	.ds 1
_symbol_3::
	.ds 1
_symbol_4::
	.ds 1
_command3::
	.ds 1
;--------------------------------------------------------
; Stack segment in internal ram 
;--------------------------------------------------------
	.area	SSEG
__start__stack:
	.ds	1

;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area DABS (ABS)

; default segment ordering for linker
	.area HOME
	.area GSINIT
	.area GSFINAL
	.area CONST
	.area INITIALIZER
	.area CODE

;--------------------------------------------------------
; interrupt vector 
;--------------------------------------------------------
	.area HOME
__interrupt_vect:
	int s_GSINIT ; reset
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area HOME
	.area GSINIT
	.area GSFINAL
	.area GSINIT
__sdcc_init_data:
; stm8_genXINIT() start
	ldw x, #l_DATA
	jreq	00002$
00001$:
	clr (s_DATA - 1, x)
	decw x
	jrne	00001$
00002$:
	ldw	x, #l_INITIALIZER
	jreq	00004$
00003$:
	ld	a, (s_INITIALIZER - 1, x)
	ld	(s_INITIALIZED - 1, x), a
	decw	x
	jrne	00003$
00004$:
; stm8_genXINIT() end
	.area GSFINAL
	jp	__sdcc_program_startup
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area HOME
	.area HOME
__sdcc_program_startup:
	jp	_main
;	return from main will return to caller
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area CODE
;	lib/stm8.h: 26: static void delay(unsigned long t)
;	-----------------------------------------
;	 function delay
;	-----------------------------------------
_delay:
	sub	sp, #4
;	lib/stm8.h: 28: while(t--);
	ldw	x, (0x09, sp)
	ldw	y, (0x07, sp)
00101$:
	ldw	(0x03, sp), x
	ldw	(0x01, sp), y
	subw	x, #0x0001
	jrnc	00112$
	decw	y
00112$:
	tnz	(0x04, sp)
	jrne	00101$
	tnz	(0x03, sp)
	jrne	00101$
	tnz	(0x02, sp)
	jrne	00101$
	tnz	(0x01, sp)
	jrne	00101$
;	lib/stm8.h: 29: }
	addw	sp, #4
	ret
;	main.c: 20: void TM1637_start(){
;	-----------------------------------------
;	 function TM1637_start
;	-----------------------------------------
_TM1637_start:
;	main.c: 21: GPIOC_ODR |= 1<<SCL_TM1637;
	ld	a, 0x500a
	or	a, #0x08
;	main.c: 22: GPIOC_ODR |= 1<<SDA_TM1637;
	ld	0x500a, a
	or	a, #0x10
	ld	0x500a, a
;	main.c: 23: delay(200);
	push	#0xc8
	clrw	x
	pushw	x
	push	#0x00
	call	_delay
	addw	sp, #4
;	main.c: 24: GPIOC_ODR &= ~(1<<SDA_TM1637);
	bres	20490, #4
;	main.c: 25: }
	ret
;	main.c: 27: void TM1637_stop(){
;	-----------------------------------------
;	 function TM1637_stop
;	-----------------------------------------
_TM1637_stop:
;	main.c: 28: GPIOC_ODR &= ~(1<<SCL_TM1637);
	bres	20490, #3
;	main.c: 29: delay(200);
	push	#0xc8
	clrw	x
	pushw	x
	push	#0x00
	call	_delay
	addw	sp, #4
;	main.c: 30: GPIOC_ODR &= ~(1<<SDA_TM1637);
	bres	20490, #4
;	main.c: 31: delay(200);
	push	#0xc8
	clrw	x
	pushw	x
	push	#0x00
	call	_delay
	addw	sp, #4
;	main.c: 32: GPIOC_ODR |= 1<<SCL_TM1637;;
	bset	20490, #3
;	main.c: 33: delay(200);
	push	#0xc8
	clrw	x
	pushw	x
	push	#0x00
	call	_delay
	addw	sp, #4
;	main.c: 34: GPIOC_ODR |= 1<<SDA_TM1637;
	bset	20490, #4
;	main.c: 35: }
	ret
;	main.c: 38: void TM1637_writeByte(char pack){
;	-----------------------------------------
;	 function TM1637_writeByte
;	-----------------------------------------
_TM1637_writeByte:
	push	a
;	main.c: 41: for(i=0;i<8;i++)  
	clr	(0x01, sp)
00108$:
;	main.c: 43: GPIOC_ODR &= ~(1<<SCL_TM1637);
	bres	20490, #3
;	main.c: 44: if(pack & 0x01)
	ld	a, (0x04, sp)
	ld	xl, a
;	main.c: 43: GPIOC_ODR &= ~(1<<SCL_TM1637);
	ld	a, 0x500a
;	main.c: 44: if(pack & 0x01)
	srlw	x
	jrnc	00102$
;	main.c: 45: { GPIOC_ODR |= 1<<SDA_TM1637;}
	or	a, #0x10
	ld	0x500a, a
	jra	00103$
00102$:
;	main.c: 46: else {GPIOC_ODR &= ~(1<<SDA_TM1637);}
	and	a, #0xef
	ld	0x500a, a
00103$:
;	main.c: 47: delay(3);
	push	#0x03
	clrw	x
	pushw	x
	push	#0x00
	call	_delay
	addw	sp, #4
;	main.c: 48: pack = pack >> 1;
	srl	(0x04, sp)
;	main.c: 49: GPIOC_ODR |= 1<<SCL_TM1637;
	bset	20490, #3
;	main.c: 50: delay(3);
	push	#0x03
	clrw	x
	pushw	x
	push	#0x00
	call	_delay
	addw	sp, #4
;	main.c: 41: for(i=0;i<8;i++)  
	inc	(0x01, sp)
	ld	a, (0x01, sp)
	cp	a, #0x08
	jrc	00108$
;	main.c: 52: GPIOC_ODR &= ~(1<<SCL_TM1637);
	bres	20490, #3
;	main.c: 53: delay(5);
	push	#0x05
	clrw	x
	pushw	x
	push	#0x00
	call	_delay
	addw	sp, #4
;	main.c: 54: GPIOC_DDR &= ~(1<<SDA_TM1637);
	bres	20492, #4
;	main.c: 55: while((GPIOC_IDR & (1<<SDA_TM1637)));
00105$:
	ld	a, 0x500b
	bcp	a, #0x10
	jrne	00105$
;	main.c: 56: GPIOC_DDR |= (1<<SDA_TM1637);
	bset	20492, #4
;	main.c: 57: GPIOC_ODR |= 1<<SCL_TM1637;
	bset	20490, #3
;	main.c: 58: delay(2);
	push	#0x02
	clrw	x
	pushw	x
	push	#0x00
	call	_delay
	addw	sp, #4
;	main.c: 59: GPIOC_ODR &= ~(1<<SCL_TM1637);
	bres	20490, #3
;	main.c: 60: }
	pop	a
	ret
;	main.c: 62: void TM1637_init()
;	-----------------------------------------
;	 function TM1637_init
;	-----------------------------------------
_TM1637_init:
;	main.c: 64: GPIOC_ODR |= (1<<SCL_TM1637) | (1<<SDA_TM1637);
	ld	a, 0x500a
	or	a, #0x18
	ld	0x500a, a
;	main.c: 65: }
	ret
;	main.c: 67: void TM1637_send(){
;	-----------------------------------------
;	 function TM1637_send
;	-----------------------------------------
_TM1637_send:
;	main.c: 68: TM1637_init();                   //Инициализируем пины SCL и SDA как выходы
	call	_TM1637_init
;	main.c: 69: TM1637_start();
	call	_TM1637_start
;	main.c: 70: pack = command1;                    //Команда записи в регистр дисплея
	clrw	x
	ld	a, _command1+0
	ld	xl, a
	ldw	_pack+0, x
;	main.c: 71: TM1637_writeByte(pack);
	ld	a, _pack+1
	push	a
	call	_TM1637_writeByte
	pop	a
;	main.c: 72: TM1637_stop();
	call	_TM1637_stop
;	main.c: 73: TM1637_start();
	call	_TM1637_start
;	main.c: 74: pack = command2;                   //Команда начального адреса для автоинкремента адреса
	clrw	x
	ld	a, _command2+0
	ld	xl, a
	ldw	_pack+0, x
;	main.c: 75: TM1637_writeByte(pack);
	ld	a, _pack+1
	push	a
	call	_TM1637_writeByte
	pop	a
;	main.c: 76: pack = symbol_1;                   //Символ 1
	clrw	x
	ld	a, _symbol_1+0
	ld	xl, a
	ldw	_pack+0, x
;	main.c: 77: TM1637_writeByte(pack);
	ld	a, _pack+1
	push	a
	call	_TM1637_writeByte
	pop	a
;	main.c: 78: pack = symbol_2;                   //Символ 2
	clrw	x
	ld	a, _symbol_2+0
	ld	xl, a
	ldw	_pack+0, x
;	main.c: 79: TM1637_writeByte(pack);
	ld	a, _pack+1
	push	a
	call	_TM1637_writeByte
	pop	a
;	main.c: 80: pack = symbol_3;                  //Символ 3
	clrw	x
	ld	a, _symbol_3+0
	ld	xl, a
	ldw	_pack+0, x
;	main.c: 81: TM1637_writeByte(pack);
	ld	a, _pack+1
	push	a
	call	_TM1637_writeByte
	pop	a
;	main.c: 82: pack = symbol_4;                   //Символ 4
	clrw	x
	ld	a, _symbol_4+0
	ld	xl, a
	ldw	_pack+0, x
;	main.c: 83: TM1637_writeByte(pack);
	ld	a, _pack+1
	push	a
	call	_TM1637_writeByte
	pop	a
;	main.c: 84: TM1637_stop();
	call	_TM1637_stop
;	main.c: 85: TM1637_start();
	call	_TM1637_start
;	main.c: 86: pack = command3;                  //Команда, задающая яркость дисплея
	clrw	x
	ld	a, _command3+0
	ld	xl, a
	ldw	_pack+0, x
;	main.c: 87: TM1637_writeByte(pack);
	ld	a, _pack+1
	push	a
	call	_TM1637_writeByte
	pop	a
;	main.c: 88: TM1637_stop();
	call	_TM1637_stop
;	main.c: 89: delay(2000);
	push	#0xd0
	push	#0x07
	clrw	x
	pushw	x
	call	_delay
	addw	sp, #4
;	main.c: 90: }
	ret
;	main.c: 92: void main(void){
;	-----------------------------------------
;	 function main
;	-----------------------------------------
_main:
;	main.c: 94: GPIOC_DDR |= (1<<SCL_TM1637) | (1<<SDA_TM1637);
	ld	a, 0x500c
	or	a, #0x18
	ld	0x500c, a
;	main.c: 95: GPIOC_CR1 |= (1<<SCL_TM1637) | (1<<SDA_TM1637);
	ld	a, 0x500d
	or	a, #0x18
	ld	0x500d, a
;	main.c: 96: GPIOC_CR2 |= (1<<SCL_TM1637) | (1<<SDA_TM1637);
	ld	a, 0x500e
	or	a, #0x18
	ld	0x500e, a
;	main.c: 99: while(1){
00102$:
;	main.c: 101: TM1637_send();
	call	_TM1637_send
	jra	00102$
;	main.c: 104: }
	ret
	.area CODE
	.area CONST
	.area INITIALIZER
__xinit__command1:
	.db #0x40	; 64
__xinit__command2:
	.db #0xc0	; 192
__xinit__symbol_1:
	.db #0x76	; 118	'v'
__xinit__symbol_2:
	.db #0x79	; 121	'y'
__xinit__symbol_3:
	.db #0x38	; 56	'8'
__xinit__symbol_4:
	.db #0x73	; 115	's'
__xinit__command3:
	.db #0x8f	; 143
	.area CABS (ABS)
